-- various functions to support printing debug info

-- debug functions toggle debug status displays along the
-- top of the screen
function init_debug()
   debug_res = false
   debug_map = false
   debug_sfx = false
   debug_mod_buffer = false
end

function debug_t(mode)
   if mode == "res" then
      debug_res = not debug_res
   elseif mode == "map" then
      debug_map = not debug_map
   elseif mode == "sfx" then
      debug_sfx = not debug_sfx
   elseif mode == "" then
      debug_mod_buffer = not debug_mod_buffer
   end
end

function debug_print()
   if debug_res then
      debug_print_res()
   end

   if debug_map then
      debug_print_map()
   end

   if debug_sfx then
      debug_print_sfx()
   end

   if debug_mod_buffer then
      debug_print_mod_buffer()
   end
end

function debug_print_res()
   clip(70, 0, 16, 24)
   print(stat(0), 70, 0, 15)
   print(stat(1), 70, 8, 15)
   print(stat(9) .. " / " .. stat(8), 70, 16, 15)
   clip()
end

function debug_print_sfx()
   clip(64, 0, 8, 8)
   print(stat(24), 64, 0, 15)
   clip()
end

function debug_print_map()
   clip(24, 0, 32, 24)
   print(camera_pos_x .. " " .. camera_pos_y, 24, 0, 15)
   print(player_pos_x .. " " .. player_pos_y, 24, 8, 15)
   print(get_biome_name(player_pos_x, player_pos_y), 24, 16, 15)
   clip()
end

function debug_print_mod_buffer()
   clip(0, 0, 16, 128)
   for k,v in pairs(mod_buffer) do
      print(k .. ": " .. tostr(v))
   end
   clip()
end
